/*

 AD9850 DDS chip driver

 OH2NLT Juha Niinikoski 02.04.2004

 AD9851 test code added 26.08.2004
 Modified for JUMA-TRX2 & Microchip C30 24.11.2660

*/

#define AD9851					// select DDS type

#include "juma-trx2.h"						// JUMA-TRX2 hardware specific definitions

// map AD9850 registers to unsigned long 
	struct dds_regs
	{
	unsigned long dds_freq;
	unsigned char dds_config;
	};

	union					// AD9850 frequency & config data, index 0 = LSB
	{
	struct dds_regs dds_regs;
	unsigned char ad9850[5];
	} dds;


/* AD9850 data transfer */

void dds_send_one( unsigned char dta )		// send one byte LSB first
	{
	char x;
	for(x=0; x<8; x++)			// do all bits
		{
		if(dta & 1)
			DDS_SER = 1;
		else
			DDS_SER = 0;

		DDS_W_CLK = 1;						// generate clock pulse
		dta = dta >> 1;						// move next bit
		DDS_W_CLK = 0;	
		}
	}

void dds_load(unsigned long set_val)		// load AD9850 from buffer			
	{
	dds.dds_regs.dds_freq = set_val;

	char x;
	for(x=0; x<5; x++)
		{
		dds_send_one(dds.ad9850[x]);		// send 40 bits
		}

	DDS_FQ_UD = 1;							// generate update pulse
	DDS_FQ_UD = 0;
	}

/* Init AD9850 interface */

void dds_init(void)
	{
	DDS_RESET = 1;							// reset AD9850
	DDS_SER = 0;
	DDS_RESET = 0;

	DDS_FQ_UD = 1;							// generate update pulse
	DDS_FQ_UD = 0;							// set serial mode

#ifdef AD9851	
	dds.dds_regs.dds_config = 0x01;			// control & phase bits = 0x01, 6xmultiplier enabled
#else
	dds.dds_regs.dds_config = 0;			// control & phase bits = 0
#endif

	}

